GnoMoreSpam = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceHook-2.1", "FuBarPlugin-2.0")
GnoMoreSpam:RegisterDB("GnoMoreSpamDB")

local dewDrop = AceLibrary("Dewdrop-2.0")
local tablet = AceLibrary("Tablet-2.0")
local L = AceLibrary("AceLocale-2.2"):new("GnoMoreSpam")

local whisperBlockCount = 0
local sayBlockCount = 0
local yellBlockCount = 0
local tradeBlockCount = 0
local generalBlockCount = 0
local guildList = {}
local friendList = {}
local sessionList = {}
local blNotifyList = {}
local authNotifyList = {}
local lastMessages = {}
local wordList = {
			"http://", 
			"www",
			"w w w",
			"[.]com",
			"[.]net",
			"[.]org",
			"dollar",
			"pounds",
			"usd",
			"gbp",
			"$%d+.+%d+g",
			"%d+g.+$%d+",
			"\226\130\172%d+.+%d+g",
			"%d+g.+\226\130\172%d+",
			"\194\163%d+.+%d+g",
			"%d+g.+\194\163%d+",
			"powerleveling",
			"[,.]com",
			"[,.]corn",
                	"100g.ca",
                	"1225game",
                	"29games",
                	"365ige",
                	"agamegold",
                	"agamegoid",
                	"auctionwowhouse",
                	"buywowgame",
                	"buyw0wgame",
                	"buyvvowgame",
                	"eusupplier",
                	"gagora",
                	"gamenoble",
                	"gmauthorization",
                	"gmworker",
                	"gmw0rker",
                	"gmworking",
                	"gmw0rking",
                	"gold4guild",
                	"goldwithyou",
                	"goldwow",
                	"helpugame",
                	"hugold",
                	"igdollar",
                	"igamebuy",
                	"igm365",
                	"igs36five",
                	"igs365",
                	"itembay",
                	"itemrate",
                	"kgs",
                	"mmoinn",
                	"ogchannel",
                	"ogmarket",
                	"ogs365",
                	"0gs365",
                	"ogs4u",
                	"okstar2008",
                	"peons4hire",
                	"peons4h1re",
                	"peons4",
                	"4hire",
                	"p3ons",
                	"peons",
                	"hir3",
                	"pkpkg",
                	"player123",
                	"ssegames",
                	"speedpanda",
                	"tusongame",
                	"wowcoming",
                	"woweurope.cn",
                	"woweuropegold",
                	"wowforever",
                	"wowfreebuy",
                	"wowgoldsky",
                	"wowgoldex",
                	"wowjx",
                	"wowpanning",
                	"wowpfs",
                	"wowspa",
                	"wowstar2008",
                	"wowsupplier",
                	"zlywy"
}
local options = {
	type="group",
	args = {
		ShowPlayerWhiteList = {
			order = 1,
			type = "execute",
			name = L["Show Player White List"],
			desc = L["Outputs your entire white list of players to the console."],
			func = function(v)
				GnoMoreSpam:Print(L["Player White List:"])
				if GnoMoreSpam.db.account.PlayerWhiteList == {} then
					GnoMoreSpam:Print(L["No white listed players were found."])
				else
					for k, v in pairs(GnoMoreSpam.db.account.PlayerWhiteList) do
						GnoMoreSpam:Print(v)
					end
				end
			end
		},
		ShowPlayerBlackList = {
			order = 2,
			type = "execute",
			name = L["Show Player Black List"],
			desc = L["Outputs your entire black list of players to the console."],
			func = function(v)
				GnoMoreSpam:Print(L["Player Black List:"])
				if GnoMoreSpam.db.account.PlayerBlackList == {} then
					GnoMoreSpam:Print(L["No black listed players were found."])
				else
					for k, v in pairs(GnoMoreSpam.db.account.PlayerBlackList) do
						GnoMoreSpam:Print(v)
					end
				end
			end
		},
		ShowWordWhiteList = {
			order = 3,
			type = "execute",
			name = "Show Word White List",
			desc = "Outputs your entire white list of words to the console.",
			func = function(v)
				GnoMoreSpam:Print(L["Word White List:"])
				if GnoMoreSpam.db.account.WordWhiteList == {} then
					GnoMoreSpam:Print(L["No white listed words were found."])
				else
					for k, v in pairs(GnoMoreSpam.db.account.WordWhiteList) do
						GnoMoreSpam:Print(k..": "..v)
					end
				end
			end
		},
		ShowWordBlackList = {
			order = 4,
			type = "execute",
			name = L["Show Word Black List"],
			desc = L["Outputs your entire black list of words to the console."],
			func = function(v)
				GnoMoreSpam:Print(L["Word Black List:"])
				if GnoMoreSpam.db.account.WordBlackList == {} then
					GnoMoreSpam:Print(L["No black listed words were found."])
				else
					for k, v in pairs(GnoMoreSpam.db.account.WordBlackList) do
						GnoMoreSpam:Print(k..": "..v)
					end
				end
			end
		},
		Blank1 = {
			order = 10,
			type = 'header'
		},
		AddWhiteListPlayer = {
			order = 11,
			type = "text",
			name = L["Add White List Player"],
			desc = L["Adds a player to your white list."],
			get = false,
			set = function(v)
				table.insert(GnoMoreSpam.db.account.PlayerWhiteList, v)
				GnoMoreSpam:Print(format(L["Player %s was added to your white list."], v))
			end,
			usage = L["<player name>"]
		},
		RemoveWhiteListPlayer = {
			order = 13,
			type = "text",
			name = L["Remove White List Player"],
			desc = L["Removes a player from your white list."],
			get = false,
			set = function(v)
				for key, player in pairs(GnoMoreSpam.db.account.PlayerWhiteList) do
					if v == player then
						table.remove(GnoMoreSpam.db.account.PlayerWhiteList, key)
						GnoMoreSpam:Print(forma(L["Player %s was removed from your white list."], player))
					end
				end
			end,
			usage = L["<player name>"]
		},
		AddBlackListPlayer = {
			order = 12,
			type = "text",
			name = L["Add Black List Player"],
			desc = L["Adds a player to your black list."],
			get = false,
			set = function(v)
				table.insert(GnoMoreSpam.db.account.PlayerBlackList, v)
				GnoMoreSpam:Print(format(L["Player %s was added to your black list."], v))
			end,
			usage = L["<player name>"]
		},
		RemoveBlackListPlayer = {
			order = 14,
			type = "text",
			name = L["Remove Black List Player"],
			desc = L["Removes a player from your black list."],
			get = false,
			set = function(v)
				for key, player in pairs(GnoMoreSpam.db.account.PlayerBlackList) do
					if v == player then
						table.remove(GnoMoreSpam.db.account.PlayerBlackList, key)
						GnoMoreSpam:Print(format(L["Player %s was removed from your black list."], player))
					end
				end
			end,
			usage = L["<player name>"]
		},
		Blank2 = {
			order = 20,
			type = 'header'
		},
		AddWhiteListWord = {
			order = 21,
			type = "text",
			name = L["Add White List Word"],
			desc = L["Adds a word to your white list."],
			get = false,
			set = function(v)
				table.insert(GnoMoreSpam.db.account.WordWhiteList, v)
				GnoMoreSpam:Print(format(L["Word %s was added to your white list."], v))
			end,
			usage = L["<word or phrase>"]
		},
		RemoveWhiteListWord = {
			order = 23,
			type = "text",
			name = L["Remove White List Word"],
			desc = L["Removes a word from your white list."],
			get = false,
			set = function(v)
				for key, word in pairs(GnoMoreSpam.db.account.WordWhiteList) do
					if v == word then
						table.remove(GnoMoreSpam.db.account.WordWhiteList, key)
						GnoMoreSpam:Print(format(L["Word %s was removed from your white list."], word))
					end
				end
			end,
			usage = L["<word or phrase>"]
		},
		AddBlackListWord = {
			order = 22,
			type = "text",
			name = L["Add Black List Word"],
			desc = L["Adds a word to your black list."],
			get = false,
			set = function(v)
				table.insert(GnoMoreSpam.db.account.WordBlackList, v)
				GnoMoreSpam:Print(format(L["Word %s was added to your black list."], v))
			end,
			usage = L["<word or phrase>"]
		},
		RemoveBlackListWord = {
			order = 24,
			type = "text",
			name = L["Remove Black List Word"],
			desc = L["Removes a word from your black list."],
			get = false,
			set = function(v)
				for key, word in pairs(GnoMoreSpam.db.account.WordBlackList) do
					if v == word then
						table.remove(GnoMoreSpam.db.account.WordBlackList, key)
						GnoMoreSpam:Print(format(L["Word %s was removed from your black list."], word))
					end
				end
			end,
			usage = L["<word or phrase>"]
		},
		Blank3 = {
			order = 30,
			type = 'header'
		},
		FilterWhisper = {
			order = 31,
			type = "toggle",
			name = L["Filter Whispers"],
			desc = L["Apply full filtering to incoming whispers."],
			get = function() return GnoMoreSpam.db.account.FilterWhisper end,
			set = function(v) GnoMoreSpam.db.account.FilterWhisper = not GnoMoreSpam.db.account.FilterWhisper end
		},
		FilterSay = {
			order = 32,
			type = "toggle",
			name = L["Filter Say"],
			desc = L["Apply full filtering to say messages."],
			get = function() return GnoMoreSpam.db.account.FilterSay end,
			set = function(v) GnoMoreSpam.db.account.FilterSay = not GnoMoreSpam.db.account.FilterSay end
		},
		FilterYell = {
			order = 33,
			type = "toggle",
			name = L["Filter Yell"],
			desc = L["Apply full filtering to yell messages."],
			get = function() return GnoMoreSpam.db.account.FilterYell end,
			set = function(v) GnoMoreSpam.db.account.FilterYell = not GnoMoreSpam.db.account.FilterYell end
		},
		FilterGeneral = {
			order = 34,
			type = "toggle",
			name = L["Filter General"],
			desc = L["Apply full filtering to general messages."],
			get = function() return GnoMoreSpam.db.account.FilterGeneral end,
			set = function(v) GnoMoreSpam.db.account.FilterGeneral = not GnoMoreSpam.db.account.FilterGeneral end
		},
		FilterTrade = {
			order = 35,
			type = "toggle",
			name = L["Filter Trade"],
			desc = L["Apply full filtering to trade messages."],
			get = function() return GnoMoreSpam.db.account.FilterTrade end,
			set = function(v) GnoMoreSpam.db.account.FilterTrade = not GnoMoreSpam.db.account.FilterTrade end
		},
		Blank4 = {
			order = 40,
			type = 'header'
		},
		AlwaysAllowFriends = {
			order = 41,
			type = "toggle",
			name = "Always Allow Friends",
			desc = "Do not filter messages from players in your friend list.",
			get = function() return GnoMoreSpam.db.account.AlwaysAllowFriends end,
			set = function(v) GnoMoreSpam.db.account.AlwaysAllowFriends = not GnoMoreSpam.db.account.AlwaysAllowFriends end
		},
		AlwaysAllowGuildMembers = {
			order = 42,
			type = "toggle",
			name = L["Always Allow Guild Members"],
			desc = L["Do not filter messages from players in your guild."],
			get = function() return GnoMoreSpam.db.account.AlwaysAllowGuildMembers end,
			set = function(v) GnoMoreSpam.db.account.AlwaysAllowGuildMembers = not GnoMoreSpam.db.account.AlwaysAllowGuildMembers end
		},
		BlockAnonymousWhispers = {
			order = 43,
			type = "toggle",
			name = L["Block Anonymous Whispers"],
			desc = L["Require anonymous players to authenticate before they can whisper you."],
			get = function() return GnoMoreSpam.db.account.BlockAnonymousWhispers end,
			set = function(v) GnoMoreSpam.db.account.BlockAnonymousWhispers = not GnoMoreSpam.db.account.BlockAnonymousWhispers end
		},
	},
}

GnoMoreSpam:RegisterChatCommand({"/gnomorespam", "/gms"}, options)
GnoMoreSpam.OnMenuRequest = options

function GnoMoreSpam:OnInitialize()
	
	self:RegisterDefaults("account", {
		PlayerWhiteList = {},
		PlayerBlackList = {},
		WordWhiteList = {},
		WordBlackList = wordList,
		FilterWhisper = true,
		FilterSay = true,
		FilterYell = true,
		FilterGeneral = true,
		FilterTrade = true,
		AlwaysAllowFriends = true,
		AlwaysAllowGuildMembers = true,
		BlockAnonymousWhispers = false,
		Debug = false
	})

	self.hideWithoutStandby = true
	self.hasIcon = true

end

function GnoMoreSpam:OnEnable()
	self:Hook("ChatFrame_MessageEventHandler", "MessageEventHandler", true)

	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	self:RegisterEvent("FRIENDLIST_UPDATE")

	self:GetGuildList()

	self:GetFriendList()

	if self:IsIconShown() then
		self:SetIcon("Interface\\Icons\\Spell_Holy_Silence")
	else
		self:HideIcon()
	end
end

function GnoMoreSpam:OnDisable()
	self:UnhookAll()
	self:UnregisterAllEvents()
end

function GnoMoreSpam:OnTooltipUpdate()
	tablet:SetHint(L["Right-Click to change options."])

	local cat = tablet:AddCategory(
		'columns', 2,
		'child_textR', 1,
		'child_textG', 1,
		'child_textB', 0,
		'child_text2R', 1,
		'child_text2G', 1,
		'child_text2B', 1
	)
	
	cat:AddLine(
		'text', L["Messages Type"],
		'textR', 1,
		'textG', 0,
		'textB', 0,
		'text2', L["Block Count"],
		'text2R', 1,
		'text2G', 0,
		'text2B', 0
	)
	cat:AddLine(
		'text', L["Whispers"],
		'text2', whisperBlockCount
	)
	cat:AddLine(
		'text', L["Say"],
		'text2', sayBlockCount
	)
	cat:AddLine(
		'text', L["Yell"],
		'text2', yellBlockCount
	)
	cat:AddLine(
		'text', L["General"],
		'text2', generalBlockCount
	)
	cat:AddLine(
		'text', L["Trade"],
		'text2', tradeBlockCount
	)
	cat:AddLine(
		'text', L["Total"],
		'text2', (whisperBlockCount + sayBlockCount + yellBlockCount + generalBlockCount + tradeBlockCount)
	)

end

function GnoMoreSpam:OnTextUpdate()
	self:SetText(format("%s blocked", (whisperBlockCount + sayBlockCount + yellBlockCount + generalBlockCount + tradeBlockCount)))
end

function GnoMoreSpam:MessageEventHandler(event)
	if self.db.account.Debug then self:Print("Begin Message Event Handler:"..event.." "..arg1) end
	if arg1 and arg1 ~= "" then
		if event == "CHAT_MSG_WHISPER_INFORM" then
			if not strfind(arg1, "<GnoMoreSpam> ") then
				if not self:IsWhiteListPlayer(arg2) and not self:IsFriend(arg2) and not self:IsGuildMember(arg2) and not self:IsSessionPlayer(arg2) then
					table.insert(sessionList, arg2)
					if self.db.account.Debug then self:Print("Added Recipient To Session List") end
				end
			else
				if self.db.account.Debug then self:Print("Ignored System Message") end
				return
			end
		elseif event == "CHAT_MSG_WHISPER" and self.db.account.FilterWhisper and not strfind(arg1, "<GnoMoreSpam> ") then
			if self:IsBlackListPlayer(arg2) then
				if self.db.account.Debug then self:Print("Sender Black Listed") end
				if not self:HaveNotifiedBlackListedPlayer(arg2) then
					table.insert(blNotifyList, arg2)
					self:SendMessage(L["Your messages are being deleted because the recipient has black listed you."], arg2)
					self:SendMessage(L["Further notifications will be supressed for the remainder of the receipient's session."], arg2)
					if self.db.account.Debug then self:Print("Black Listed Sender Notified") end
				end
				whisperBlockCount = whisperBlockCount + 1
				self:UpdateText()
				return
			elseif arg6 == "GM" or self:IsWhiteListPlayer(arg2) or (self:IsFriend(arg2) and self.db.account.AlwaysAllowFriends) or (self:IsGuildMember(arg2) and self.db.account.AlwaysAllowGuildMembers) then
				if self.db.account.Debug then self:Print("Sender immune") end
			elseif self.db.account.BlockAnonymousWhispers and strlower(arg1) == strlower("gnomoreauth "..arg2) then
				if not self:IsSessionPlayer(arg2) then
					table.insert(sessionList, arg2)
					self:SendMessage(L["Authentication was sucessful. You can now message the recipient for the remainder of their session."], arg2)
					if self.db.account.Debug then self:Print("Sender Authenticated") end
				end
				return
			elseif self:CheckMessage(arg1) then
				if self.db.account.BlockAnonymousWhispers and not self:IsSessionPlayer(arg2) then
					if not self:HaveRequestedAuth(arg2) then
						table.insert(authNotifyList, arg2)
						self:SendMessage(L["Your message could not be delivered because the recipient has chosen to block unsolicited whispers."], arg2)
						self:SendMessage(L["To message the recipient you must first authenticate by sending them a whisper containing 'gnomoreauth <player name>' without the quotes."], arg2)
						if self.db.account.Debug then self:Print("Requested Auth") end
					end
					return
				end
			else
				if not lastMessages[arg2] then
					lastMessages[arg2] = {}
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
					if self.db.account.Debug then self:Print("New Message Detected") end
				elseif lastMessages[arg2].message == arg1 and time() - lastMessages[arg2].time < 10 then
					lastMessages[arg2].count = lastMessages[arg2].count + 1
					if self.db.account.Debug then self:Print("Duplicate Message Ignored") end
					return
				else
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
					if self.db.account.Debug then self:Print("Message Changed") end
				end
				self:SendMessage(L["Your message was automatically deleted because it contained one or more black listed words or phrases."], arg2)
				whisperBlockCount = whisperBlockCount + 1
				lastMessages[arg2].count = 0
				self:UpdateText()
				if self.db.account.Debug then self:Print("Message Deleted") end
				return
			end
		elseif event == "CHAT_MSG_SAY" and self.db.account.FilterSay and arg2 ~= UnitName("player") then
			if self:IsBlackListPlayer(arg2) then
				if self.db.account.Debug then self:Print("Sender Black Listed") end
				sayBlockCount = sayBlockCount + 1
				self:UpdateText()
				return
			elseif arg6 == "GM" or self:IsWhiteListPlayer(arg2) or (self:IsFriend(arg2) and self.db.account.AlwaysAllowFriends) or (self:IsGuildMember(arg2) and self.db.account.AlwaysAllowGuildMembers) then
				if self.db.account.Debug then self:Print("Sender immune") end
			elseif self:CheckMessage(arg1) then
				if not lastMessages[arg2] then
					lastMessages[arg2] = {}
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				elseif lastMessages[arg2].message == arg1 and time() - lastMessages[arg2].time < 10 then
					lastMessages[arg2].count = lastMessages[arg2].count + 1
					return
				else
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				end
			else
				if not lastMessages[arg2] then
					lastMessages[arg2] = {}
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				elseif lastMessages[arg2].message == arg1 and time() - lastMessages[arg2].time < 10 then
					lastMessages[arg2].count = lastMessages[arg2].count + 1
					return
				else
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				end
				sayBlockCount = sayBlockCount + 1
				self:UpdateText()
				return
			end
		elseif event == "CHAT_MSG_YELL" and self.db.account.FilterYell and arg2 ~= UnitName("player") then
			if self:IsBlackListPlayer(arg2) then
				if self.db.account.Debug then self:Print("Sender Black Listed") end
				yellBlockCount = yellBlockCount + 1
				self:UpdateText()
				return
			elseif arg6 == "GM" or self:IsWhiteListPlayer(arg2) or (self:IsFriend(arg2) and self.db.account.AlwaysAllowFriends) or (self:IsGuildMember(arg2) and self.db.account.AlwaysAllowGuildMembers) then
				if self.db.account.Debug then self:Print("Sender immune") end
			elseif self:CheckMessage(arg1) then
				if not lastMessages[arg2] then
					lastMessages[arg2] = {}
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				elseif lastMessages[arg2].message == arg1 and time() - lastMessages[arg2].time < 10 then
					lastMessages[arg2].count = lastMessages[arg2].count + 1
					return
				else
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				end
			else
				if not lastMessages[arg2] then
					lastMessages[arg2] = {}
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				elseif lastMessages[arg2].message == arg1 and time() - lastMessages[arg2].time < 10 then
					lastMessages[arg2].count = lastMessages[arg2].count + 1
					return
				else
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				end
				yellBlockCount = yellBlockCount + 1
				self:UpdateText()
				return
			end
		elseif event == "CHAT_MSG_CHANNEL" and self.db.account.FilterGeneral and arg2 ~= UnitName("player") and strfind(arg4, "General") then
			if self:IsBlackListPlayer(arg2) then
				if self.db.account.Debug then self:Print("Sender Black Listed") end
				generalBlockCount = generalBlockCount + 1
				self:UpdateText()
				return
			elseif arg6 == "GM" or self:IsWhiteListPlayer(arg2) or (self:IsFriend(arg2) and self.db.account.AlwaysAllowFriends) or (self:IsGuildMember(arg2) and self.db.account.AlwaysAllowGuildMembers) then
				if self.db.account.Debug then self:Print("Sender immune") end
			elseif self:CheckMessage(arg1) then
				if not lastMessages[arg2] then
					lastMessages[arg2] = {}
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				elseif lastMessages[arg2].message == arg1 and time() - lastMessages[arg2].time < 10 then
					lastMessages[arg2].count = lastMessages[arg2].count + 1
					return
				else
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				end
			else
				if not lastMessages[arg2] then
					lastMessages[arg2] = {}
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				elseif lastMessages[arg2].message == arg1 and time() - lastMessages[arg2].time < 10 then
					lastMessages[arg2].count = lastMessages[arg2].count + 1
					return
				else
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				end
				generalBlockCount = generalBlockCount + 1
				self:UpdateText()
				return
			end
		elseif event == "CHAT_MSG_CHANNEL" and self.db.account.FilterTrade and arg2 ~= UnitName("player") and strfind(arg4, "Trade") then
			if self:IsBlackListPlayer(arg2) then
				if self.db.account.Debug then self:Print("Sender Black Listed") end
				tradeBlockCount = tradeBlockCount + 1
				self:UpdateText()
				return
			elseif arg6 == "GM" or self:IsWhiteListPlayer(arg2) or (self:IsFriend(arg2) and self.db.account.AlwaysAllowFriends) or (self:IsGuildMember(arg2) and self.db.account.AlwaysAllowGuildMembers) then
				if self.db.account.Debug then self:Print("Sender immune") end
			elseif self:CheckMessage(arg1) then
				if not lastMessages[arg2] then
					lastMessages[arg2] = {}
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				elseif lastMessages[arg2].message == arg1 and time() - lastMessages[arg2].time < 10 then
					lastMessages[arg2].count = lastMessages[arg2].count + 1
					return
				else
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				end
			else
				if not lastMessages[arg2] then
					lastMessages[arg2] = {}
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				elseif lastMessages[arg2].message == arg1 and time() - lastMessages[arg2].time < 10 then
					lastMessages[arg2].count = lastMessages[arg2].count + 1
					return
				else
					lastMessages[arg2].message = arg1
					lastMessages[arg2].time = time()
					lastMessages[arg2].count = 1
				end
				tradeBlockCount = tradeBlockCount + 1
				self:UpdateText()
				return
			end
			
		end
	end
	
	return self.hooks["ChatFrame_MessageEventHandler"](event)
end


function GnoMoreSpam:CheckMessage(message)
	if self.db.account.Debug then self:Print("Checking message: "..message) end
	for k, v in pairs(self.db.account.WordWhiteList) do
		if string.find(string.lower(message), string.lower(v)) ~= nil then
			return true
		end
	end

	for k, v in pairs(self.db.account.WordBlackList) do
		if string.find(string.lower(message), string.lower(v)) ~= nil then
			return false
		end
	end

	return true
end

function GnoMoreSpam:HaveRequestedAuth(player)
	if self.db.account.Debug then self:Print("Checking if have request auth from: "..player) end
	for k, v in pairs(authNotifyList) do
		if v == player then
			return true
		end
	end

	return false
end

function GnoMoreSpam:HaveNotifiedBlackListedPlayer(player)
	if self.db.account.Debug then self:Print("Checking if BL player notifed: "..player) end
	for k, v in pairs(blNotifyList) do
		if v == player then
			return true
		end
	end

	return false
end

function GnoMoreSpam:IsBlackListPlayer(player)
	if self.db.account.Debug then self:Print("Checking if player is black listed: "..player) end
	for k, v in pairs(self.db.account.PlayerBlackList) do
		if v == player then
			return true
		end
	end

	return false
end

function GnoMoreSpam:IsWhiteListPlayer(player)
	if self.db.account.Debug then self:Print("Checking if player is white listed: "..player) end
	for k, v in pairs(self.db.account.PlayerWhiteList) do
		if v == player then
			return true
		end
	end

	return false
end

function GnoMoreSpam:IsFriend(player)
	if self.db.account.Debug then self:Print("Checking if player is friend: "..player) end
	for k, v in pairs(friendList) do
		if v == player then
			return true
		end
	end

	return false
end

function GnoMoreSpam:IsGuildMember(player)
	if self.db.account.Debug then self:Print("Checking if player is guild member: "..player) end
	for k, v in pairs(guildList) do
		if v == player then
			return true
		end
	end

	return false
end

function GnoMoreSpam:IsSessionPlayer(player)
	if self.db.account.Debug then self:Print("Checking if player is session player: "..player) end
	for k, v in pairs(sessionList) do
		if v == player then
			return true
		end
	end

	return false
end

function GnoMoreSpam:GetFriendList()
	if self.db.account.Debug then self:Print("Getting friends list.") end
	local nbfr = GetNumFriends()
	local friendlist = {}
	for k = 1, nbfr do
		local name, level, class, area, connected, status = GetFriendInfo(k)
		table.insert(friendlist, name)
	end
	friendList = friendlist
end

function GnoMoreSpam:GetGuildList()
         GuildRoster()
end

function GnoMoreSpam:GUILD_ROSTER_UPDATE()
	if self.db.account.Debug then self:Print("Getting guild list.") end
        local guildCount = GetNumGuildMembers(true)
        local guildMembers = {}
        
        for k = 1, guildCount do
            local name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(k)
            table.insert(guildMembers, name)
        end
        
        guildList = guildMembers
end

function GnoMoreSpam:FRIENDLIST_UPDATE()
	self:GetFriendList()
end

function GnoMoreSpam:ZONE_CHANGED_NEW_AREA()
	lastMessages = {}
end

function GnoMoreSpam:SendMessage(message, player)
	SendChatMessage("<GnoMoreSpam> "..message, "WHISPER", nil, player)
end